/* 
 * File:   main-KSA.c
 * Author: Wendian
 *
 * Created on November 12, 2015, 1:47 PM
 */

// DDS output thru PWM on timer0 OC0A (pin B.3)
// Mega644 version
// Produces a Karplus-Strong string sound

#include <inttypes.h>
#include "config.h"
#include "tft_master.h"
#include "tft_gfx.h"
// need for rand function
#include <stdlib.h>

// threading library
#include <plib.h>
// config.h sets 40 MHz
#define	SYS_FREQ 40000000
#include "pt_cornell_1_2.h"
#include <stdlib.h> 		// for rand
#include <stdio.h>
// set up serial for debugging
 

//Convert float to fix. a is a float
typedef signed int fix16 ;
#define float2fix16(a) ((fix16)((a)*65536.0)) // 2^16
#define fix2float16(a) ((float)(a)/65536.0)

// Fast fixed point multiply assembler macro
#define multfix16(a,b) ((fix16)(((( signed long long)(a))*(( signed long long)(b)))>>16)) //multiply two fixed 16:16

int generate_period = 2000 ; // PWM sample time
int pwm_on_time = 500 ;

// tune the string by it's length 
int string_length ;

#define max_amp 32767

// The DDS variables 
volatile unsigned int acc_1;
volatile unsigned int inc_1 ;
volatile unsigned char high_1 ;
 
// attack and decay constants
volatile unsigned char rise_1 ;
volatile unsigned char fall_1 ; 
// attack and decay waveforms
volatile long long int amp_rise_1 ;
volatile long long int amp_fall_1 ;

// amplitude waveforms = attack * decay waveforms
volatile int amp_1;
// amplitude scaling constant
volatile unsigned char a_1; 

// the output waves to be added together			
volatile signed int wave_1=0 ;
volatile unsigned char do_pluck ;
long int test_overflow ;


// time counts at 8000 Hz
// all string amplitudes are stored in 8.8 fixed point
volatile unsigned int time ;
volatile signed int string[256],stringp[256],string1[256],string2[256],string3[256], all_output=0,all_output_old=0, all_input_old=0, all_input=0,low_output=0,low_input=0,low_input_old=0 ;
signed int tune, damping ;
volatile char pluck, pushed;
volatile int ptrin, ptrout ;

char buffer[60];


// noise table 
volatile unsigned int n,m,i,j;
volatile signed int noise_table[256] ;

void __ISR(_TIMER_2_VECTOR, ipl2) Timer2Handler(void) //20k sample
{
    mT2ClearIntFlag();
	pwm_on_time =  500 + (fix2float16(string1[n])*5) ; //sample
    SetDCOC2PWM(pwm_on_time);
    
 
    low_output = multfix16(damping, (string1[n] + string1[m])>>1) ;
 	// tuning all-pass filter
	all_output = multfix16(tune,(low_output - all_output_old)) + all_input_old ;
    
    string1[n] = all_output;
    // all-pass state vars
    all_output_old = string1[n];
    all_input_old = low_output;
	

    if (n==string_length) n=1; 
    else n=n+1;  
     if (m==string_length) m=1; 
    else m=m+1;  
    
    
	if (pluck==1) {
		for (i=0; i<string_length; i++) 
        {
			string1[i] = noise_table[i] <<16  ;
            string2[i] = noise_table[i+10] <<16  ;
            string3[i] = noise_table[i+20] <<16  ;
            
		 }

		pluck = 0;
        n=1;
        m=2;
	}

}
 
void main(void) {
    ANSELA = 0; ANSELB = 0;
  // === config threads ==========
    PT_setup();
    INTEnableSystemMultiVectoredInt();
    j=1;
   // init the noise table
   for (i=0; i<256; i++)
    {
          //noise_table[i] =  (i<25)? i*10 : (i<55)?350-4*i :(i<65)? 7*i-255 : 200-i;
       if(i<5){
           j=j+40;//250
           noise_table[i]=j;
       }
       else if(i<15){
           j=j-10;//150
           noise_table[i]=j;
       }
       else if(i<20){
           j=j+14;//220
           noise_table[i]=j;
       }
       else if(i<30){
           j=j-9;//130
           noise_table[i]=j;
       }
       else if(i<35){
           j=j+14;//200
           noise_table[i]=j;
       }
       else {
           j=j-1;//200
           noise_table[i]=j;
       }
         // noise_table[i] =  (i<25)?  :(i<35)?255 :0;
    }  	
	
	// string parameters ///////////////////////////////////////////////
	string_length = 61 ; // coarse tuning for C3
	tune = float2fix16(0.12) ; // fine tuning for C3
	damping = float2fix16(0.996) ; // must be 0.5<damping<=0.996
	
  

    
    // set up compare3 for PWM mode
    OpenOC2(OC_ON | OC_TIMER2_SRC | OC_PWM_FAULT_PIN_DISABLE , pwm_on_time, pwm_on_time); //
    // OC2 is PPS group 4, map to RPB9 (pin 18)
    PPSOutput(2, RPB5, OC2);
    // mPORTASetPinsDigitalOut(BIT_3);    //Set port as output -- not needed

   
    
  	OpenTimer2(T2_ON | T2_SOURCE_INT | T2_PS_1_1, generate_period);
    ConfigIntTimer2(T2_INT_ON | T2_INT_PRIOR_2); 
    mT2ClearIntFlag(); //  clear the interrupt flag 
   // turn on all ISRs

    tft_init_hw();
    tft_begin();
    tft_fillScreen(ILI9340_BLACK);
    tft_setRotation(0);
    
   while(1) 
   {  
       for(i=40;i<70;i=i+20)
       {
          
       
           
           pluck=1;
         
           delay_ms(2000);
            /*for(j=0;j<256;j++)
           {
               string[j]=0;
           }*/

       }
        
    
   }    
}

